import "Gillothrin.Items.VindarPatch";
import "Gillothrin.Items.DataOptions";

DataLoader = class (Turbine.Object);
function DataLoader:Constructor()
  Turbine.Object.Constructor(self);
  self.namespace = pluginName.."Options";
  self.storage = {};
  self:LoadData();
end

function DataLoader:Add(obj)
  table.insert(self.storage,obj);
end

function DataLoader:Remove(idx)
  table.remove(self.storage,idx);
end

function DataLoader:LoadData()
  local euroFormat=(tonumber("1,000")==1);
  if euroFormat then
    function euroNormalize(value) return tonumber((string.gsub(value,"%.",","))) end
  else
    function euroNormalize(value) return tonumber((string.gsub(value,",","."))) end
  end
  local obj = Turbine.Object();
  pcall(function() obj = PatchDataLoad( Turbine.DataScope.Character, self.namespace)  end );

  -- Old format
  if obj == nil then
    self.storage[1] = DataOptions();
  elseif #obj == 0 then
    self.storage[1] = DataOptions(obj);
  else
    for i=1,#obj do
      self.storage[i] = DataOptions(obj[i]);
    end
  end
end

local function clone (t)
  if type(t) ~= "table" then return t end
  local meta = getmetatable(t)
  local target = {}
  for k, v in pairs(t) do
    if type(v) == "table" then
      target[k] = clone(v)
    else
      target[k] = v
    end
  end
  setmetatable(target, meta)
  return target
end

function DataLoader:SaveData()
  local obj = clone(self.storage);
  pcall(function() PatchDataSave( Turbine.DataScope.Character, self.namespace, obj) end);
end


