
DataOptions = class(Turbine.Object);
function DataOptions:Constructor(obj)
  Turbine.Object.Constructor(self);
  self:LoadData(obj);

  if(self.notSelectedItems == nil) then
    self.notSelectedItems = {};
  end
  if(self.seenWalletItems == nil) then
    self.seenWalletItems = {};
  end

  if self.frameback == nil then
    self.frameback = {};
    self.frameback.a = 255;
    self.frameback.r = 7;
    self.frameback.g = 32;
    self.frameback.b = 71;
  end

  if self.iconback == nil then
    self.iconback = {};
    self.iconback.a = 255;
    self.iconback.r = 7;
    self.iconback.g = 32;
    self.iconback.b = 71;
  end

  if self.nrback == nil then
    self.nrback = {};
    self.nrback.a = 255
    self.nrback.r = 2
    self.nrback.g = 44;
    self.nrback.b = 112;
  end

  if self.vertback == nil then
    self.vertback = {};
    self.vertback.a = 102;
    self.vertback.r = 0
    self.vertback.g = 0;
    self.vertback.b = 0;
  end

  if self.textcolor == nil then
    self.textcolor = {};
    self.textcolor.a = 255;
    self.textcolor.r = 255;
    self.textcolor.b = 255;
    self.textcolor.g = 255;
  end

  -- Behavioural data
  if self.oneline == nil then self.oneline = false; end;
  if self.nopack == nil then self.nopack = false; end;

  -- Window data
  if self.padding == nil then self.padding = 2; end;
  if self.defaultRowHeight == nil then self.defaultRowHeight = 20; end;
  if self.defaultWidth == nil then self.defaultWidth = 300; end;

  if self.mainWidth == nil then self.mainWidth = self.defaultWidth; end;
  if self.mainHeight == nil then self.mainHeight = self.defaultHeight; end;

  if self.mainTop == nil then self.mainTop = 100; end;
  if self.mainLeft == nil then self.mainLeft = 100; end;

  if self.resizerWidth == nil then self.resizerWidth = 10; end;

  -- Icons data
  if self.charWidth == nil then self.charWidth = 7; end;
  if self.iconImageWidth == nil then self.iconImageWidth = 16; end;
  if self.iconImageHeight == nil then self.iconImageHeight = 16; end;

  if self.topPadding == nil then self.topPadding = 1; end;
  if self.bottomPadding == nil then self.bottomPadding = 1; end;
  if self.leftPadding == nil then self.leftPadding = 1; end;
  if self.spacer == nil then self.spacer = 2; end;

  if self.tickrate == nil then self.tickrate = 100; end;
  
  if self.tabname == nil then self.tabname = "Window"; end;

end

function DataOptions:LoadData(obj)
  if obj ~= nil then
    self.mainLeft = obj.mainLeft;
    self.mainTop = obj.mainTop;
    self.mainWidth = obj.mainWidth;
    self.mainHeight = obj.mainHeight;
    self.nrback = obj.nrback;
    self.iconback = obj.iconback;
    self.vertback = obj.vertback;
    self.notSelectedItems = obj.notSelectedItems;
    self.seenWalletItems = obj.seenWalletItems;
    self.oneline = obj.oneline;
    self.nopack = obj.nopack;
    self.frameback = obj.frameback;
    self.padding  = obj.padding;
    self.defaultRowHeight = obj.defaultRowHeight;
    self.defaultWidth = obj.defaultWidth;
    self.resizerWidth = obj.resizerWidth;

    self.charWidth = obj.charWidth;
    self.iconImageWidth = obj.iconImageWidth;
    self.iconImageHeight = obj.iconImageHeight;

    self.topPadding = obj.topPadding;
    self.bottomPadding = obj.bottomPadding;
    self.leftPadding = obj.leftPadding;
    self.spacer = obj.spacer;

    self.tickrate = obj.tickrate;
    self.textcolor = obj.textcolor;
    self.tabname = obj.tabname;
  end
end
