import "Gillothrin.Items.Wallet";
import "Gillothrin.Items.ItemsWindow";
import "Gillothrin.Items.OptionsControl";

ItemWalletInstance = class (Turbine.Object)
function ItemWalletInstance:Constructor(optionsObj,player)
  Turbine.Object.Constructor(self);
  
  self.optionsObj = optionsObj;
  
  self.playerWallet=Wallet(player,self.optionsObj);

  self.itemsWindow = ItemsWindow(self.optionsObj,self.playerWallet);
  self.optionsControl = OptionsControl(self.optionsObj,self.playerWallet);
  
  local this = self;
  self.ReColorHandler = function(s,a) this:ReColor(s,a) end;
  self.ReColorBarHandler = function(s,a) this:ReColorBar(s,a) end;
  AddCallback(self.optionsControl,"ColorChanged",self.ReColorHandler);
  AddCallback(self.optionsControl,"BarColorChanged",self.ReColorBarHandler);
  
  self.itemsWindow:LoadWindow();
  self.optionsControl:RepaintOptionsControl();
end

function ItemWalletInstance:SetDefaultPosition(iter)
  self.itemsWindow:SetDefaultPosition(iter);
end

function ItemWalletInstance:ReColorBar(s,a)
  self.itemsWindow:ReColorBar(s,a);
end

function ItemWalletInstance:ReColor(s,a)
  self.itemsWindow:ReColor(s,a);
end

function ItemWalletInstance:Update()
  self.itemsWindow:RepaintItemInfo();
end

function ItemWalletInstance:SetVisible(flag)
  self.itemsWindow:SetVisible(flag);
  if flag then
    self.itemsWindow:Activate();
  else
    self.itemsWindow:Close();
  end
end

function ItemWalletInstance:Unload()
  self:SetVisible(false);
  self.optionsControl:Unload();
  RemoveCallback(self.optionsControl,"ColorChanged",self.ReColorHandler);
  RemoveCallback(self.optionsControl,"BarColorChanged",self.ReColorBarHandler);
  self.itemsWindow:Unload();
  self.playerWallet:Unload();
  self.itemsWindow:SetParent(nil)
  self.optionsControl:SetParent(nil);
  self.itemsWindow = nil;
  self.optionsControl = nil;
  self.playerWallet = nil;
end

function ItemWalletInstance:Refresh()
  self:Update();
  self.optionsControl:RepaintOptionsControl();
end