import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Gillothrin.Items.GUI";
import "Gillothrin.Items.ListBox";

MainOptionsControl = class (Turbine.UI.Control)
function MainOptionsControl:Constructor(parent,tabbedPane)
  Turbine.UI.Control.Constructor(self);
  self.tabbedPane = tabbedPane;
  self.mainPane = Turbine.UI.Control();
  self.mainPane:SetParent(self);
  self:SetBackColor(Turbine.UI.Color(0,0,0))

  self.buttonsPane = Turbine.UI.Control();
  self.buttonsPane:SetParent(self.mainPane);

  self.newButton = VButton(L["newtab"],10,10,100,30);
  self.newButton:SetParent(self.buttonsPane);
  self.newButton.MouseClick = function(s,a)
    if not self.createNewPane:IsVisible() then
      self.deletePane:SetVisible(false);
      self.createNewPane:SetVisible(true);
    end
  end

  self.deleteButton = VButton(L["deletetab"],150,10,100,30);
  self.deleteButton:SetParent(self.buttonsPane);
  self.deleteButton.MouseClick = function(s,a)
    if not self.deletePane:IsVisible() then
      self.deletePane:SetVisible(true);
      self.deletePane.list:SetEnabled(true);
      self.createNewPane:SetVisible(false);
    end
  end

  self.createNewPane = Turbine.UI.Control();
  self.createNewPane:SetParent(self.mainPane);
  self.createNewPane:SetVisible(true);

  self.createNewPane.newtab = Turbine.UI.Lotro.TextBox();
  self.createNewPane.newtab:SetParent(self.createNewPane);
  self.createNewPane.newtab:SetPosition(15,5);
  self.createNewPane.newtab:SetSize(80,20);
  self.createNewPane.newtab:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
  self.createNewPane.newtab:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
  self.createNewPane.newtab:SetForeColor(Turbine.UI.Color(0.75,0.7,0.6));
  self.createNewPane.newtab:SetMultiline(false);
  self.createNewPane.newtab:SetText("  "..L["tabname"]);
  self.createNewPane.newtab.clear = true;
  self.createNewPane.newtab.TextChanged = function(s,a)
    local txt = s:GetText();
    if string.len(txt) > 7 then
      s:SetText(string.sub(txt,1,7));
    end
  end;

  self.createNewPane.OK = VButton(L["ok"],10,40,100,20);
  self.createNewPane.OK:SetParent(self.createNewPane);
  self.createNewPane.OK.MouseClick = function(s,a)
    local tabtext = self.createNewPane.newtab:GetText();
    if tabtext ~= nil and not self.createNewPane.newtab.clear then
      ExecuteCallback(parent,"InstanceAdded",{ name = tabtext});
      self.createNewPane.newtab:SetText(" "..L["tabname"]);
      self.createNewPane.newtab.clear = true;
    end
    self.createNewPane.newtab.focused = false;
  end
  self.createNewPane.cancel = VButton(L["cancel"],150,40,100,20);
  self.createNewPane.cancel:SetParent(self.createNewPane);
  self.createNewPane.cancel.MouseClick = function(s,a)
    self.createNewPane.newtab:SetText(" "..L["tabname"]);
    self.createNewPane.newtab.clear = true;
    self.createNewPane:SetVisible(false);
  end

  if debugMode then
    self.createNewPane.gc = VButton("gc",10,70,50,20);
    self.createNewPane.gc:SetParent(self.createNewPane);
    self.createNewPane.gc.MouseClick = function(s,a)
      debug(Dump(collectgarbage("count")*1024));
    end;

    self.createNewPane.gbg = VButton("gbg",60,70,50,20);
    self.createNewPane.gbg:SetParent(self.createNewPane);
    self.createNewPane.gbg.MouseClick = function(s,a)
      debug(Dump(collectgarbage("collect")));
    end;
  end
  self.createNewPane.newtab.FocusGained = function(sender,args)
    if (not self.createNewPane.newtab.focused) then
      self.createNewPane.newtab.focused = true;
      self.createNewPane.newtab:SetText("");
    end
    self.createNewPane.newtab:SetForeColor(Turbine.UI.Color(1,1,1));

    self.createNewPane.newtab.text = self.createNewPane.newtab:GetText();
    self.createNewPane.newtab.clear = false;

    self.createNewPane.newtab:SetWantsKeyEvents(true);
    self.createNewPane.newtab:SetWantsUpdates(true);
  end

  self.createNewPane.newtab.FocusLost = function(sender,args)
    self.createNewPane.newtab:SetWantsKeyEvents(false);
    self.createNewPane.newtab:SetWantsUpdates(false);

    if (self.createNewPane.newtab.clear or self.createNewPane.newtab:GetText() == "") then
      self.createNewPane.newtab.focused = false;
      self.createNewPane.newtab:SetForeColor(Turbine.UI.Color(0.75,0.7,0.6));
      self.createNewPane.newtab:SetText(" "..L["tabname"]);
      self.createNewPane.newtab.clear = true;
    else
      self.createNewPane.newtab:SetForeColor(Turbine.UI.Color(0.75,0.7,0.6));
    end
  end

  self.deletePane = Turbine.UI.Control();
  self.deletePane:SetParent(self.mainPane);
  self.deletePane:SetVisible(false);
  self.deletePane.list = ListBox();
  self.deletePane.list:SetParent(self.deletePane);

  self.deletePane.delete = VButton(L["delete"],85,135,100,20);
  self.deletePane.delete:SetParent(self.deletePane);
  self.deletePane.delete.MouseClick = function(s,a)
    local idx = self.deletePane.list:GetSelection();
    if idx ~= nil and idx > -1 then
      local b = {index = idx};
      ExecuteCallback(parent,"InstanceRemoved",b);
      self:Layout();
    end
  end
end

function MainOptionsControl:PopulateList(tabbedPane,list)
  list:ClearItems();
  local w,h = list:GetSize();
  local tabs = tabbedPane:GetTabs();
  for i=2,#tabs do
    list:AddItem(tabs[i]:GetName(),i);
  end
end


function MainOptionsControl:Layout()
  self:SetSize(400,200);
  self.mainPane:SetPosition(0,0);
  self.mainPane:SetSize(400,300);
  self.buttonsPane:SetPosition(0,0);
  self.buttonsPane:SetSize(400,40);

  self.createNewPane:SetPosition(0,40);
  self.createNewPane:SetSize(400,175);

  self.deletePane:SetPosition(0,40);
  self.deletePane:SetSize(400,200);

  self.deletePane.list:SetPosition(0,0);
  self.deletePane.list:SetSize(400,125);

  self:PopulateList(self.tabbedPane,self.deletePane.list);
  self.deletePane.list:SetEnabled(true);

end
