import "Turbine.UI.Lotro";

OptionsWindow = class (Turbine.UI.Lotro.Window)
function OptionsWindow:Constructor(parent)
  Turbine.UI.Lotro.Window.Constructor(self);
  self:SetText(L["options"]);
  self:SetSize(472,650);
  self.listBox = Turbine.UI.ListBox();
  self.listBox:SetParent(self);
  self.listBox:SetSize(405,590);
  self.listBox:SetPosition(35,40);
  self.listBox:SetBackColor(Turbine.UI.Color(rgb(230),rgb(0),0,0));

  self.mainOptionsTabbedPane = TabbedPane();
  self.mainOptionsTabbedPane:SetParent(self.listBox);
  AddCallback(self.mainOptionsTabbedPane,"SelectedTabChanged",function(s,a) ExecuteCallback(self,"",a)end);
  local moc = MainOptionsControl(parent,self.mainOptionsTabbedPane);
  
  self.tabnamehandler = function(s,a) ExecuteCallback(self,"TabNameChanged",a); end;
  AddCallback(self.mainOptionsTabbedPane,"TabNameChanged",self.tabnamehandler);
  
  self.mainOptionsTabbedPane:AddTab(L["generaltab"],moc);
  moc:Layout();

  self.moc = moc;
  self.mainOptionsTabbedPane:SelectTab(1);
  self.mainOptionsTabbedPane:SetSize(moc:GetWidth(),moc:GetHeight());
  self.listBox:AddItem(self.mainOptionsTabbedPane);

  local hbar = Turbine.UI.Lotro.ScrollBar();
  hbar:SetParent(self);
  hbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
  hbar:SetPosition(35,620);
  hbar:SetSize(405,10);

  self.listBox:SetHorizontalScrollBar(hbar);

end

function OptionsWindow:AddControl(tabname,control)
  self.mainOptionsTabbedPane:AddTab(tabname,control);
end

function OptionsWindow:RemoveControl(index)
  self.mainOptionsTabbedPane:RemoveTab(index);
end

function OptionsWindow:Layout()
  self.moc:Layout();
  self.mainOptionsTabbedPane:Layout();
end

function OptionsWindow:Closed()
  ExecuteCallback(self,"Closed",{});
end

